%% DEMO case - edge detection in 2D images
% need to be set
% - sigma - which define added noise
% - degree - polynomial degree (K+1)
% - delta - model error
% - name_of_image - name of loaded image
% - type_of_polynomials - type of used polynomials: 1 - standard, 2 -
% orthogonal
% - param_method.lambda - lambda
% - param_solver.maxit - maximum number of iterations 
% thresholds - thresholds for edges detection
% - t_clean - threshold for clean image
% - t_noisy - threshold for noisy image
% - t_recon - threshold for reconstructed image
% - t_diff - threshold for differences of parameterization coefficients
%-----------------------------------------------------

clear variables
close all

% ----------------------------------------------------

% Experiment 1a (in paper)
sigma = 20;
degree = 3;
delta = 4000; 
type_of_polynomials = 1; %standard basis

name_of_image='coins.png';

[signal_characteristics]=lib_add_noise_to_image(sigma, name_of_image);

param_method.lambda = 1; 
param_solver.maxit = 500;       % maximum number of iterations

thresholds.t_clean=0.15; 
thresholds.t_noisy=0.24;
thresholds.t_recon=0.14;
thresholds.t_diff=0.12;

% --------------------------------------------------------------

% Experiment 1b (NOT in paper)
% sigma = 20;
% degree = 3;
% delta = 8000; 
% type_of_polynomials = 4; %orthogonal basis
% 
% name_of_image='coins.png';
% 
% [signal_characteristics]=lib_add_noise_to_image(sigma, name_of_image);
% 
% param_method.lambda = 1; 
% param_solver.maxit = 10000;       % maximum number of iterations
% 
% thresholds.t_clean=0.15; 
% thresholds.t_noisy=0.24;
% thresholds.t_recon=0.12;
% thresholds.t_diff=0.12;

% ----------------------------------------------------

% Experiment 2a (in paper)
% sigma = 30;
% degree = 3;
% delta = 6000;
% name_of_image='coins.png';
% type_of_polynomials = 1; %standard basis

% [signal_characteristics]=lib_add_noise_to_image(sigma, name_of_image);
% 
% param_method.lambda = 1; %signal_characteristics.N/signal_characteristics.M;
% param_solver.maxit = 500;       % maximum number of iterations

% thresholds.t_clean=0.15; 
% thresholds.t_noisy=0.29;
% thresholds.t_recon=0.16;
% thresholds.t_diff=0.18;

% ---------------------------------------------------------------------

% Experiment 2b (in paper)
% sigma = 30;
% degree = 3;
% delta = 8000;
% name_of_image='coins.png';
% type_of_polynomials = 4; %orthogonal basis
% 
% [signal_characteristics]=lib_add_noise_to_image(sigma, name_of_image);
% 
% param_method.lambda = 1; %signal_characteristics.N/signal_characteristics.M;
% param_solver.maxit = 10000;       % maximum number of iterations
% 
% thresholds.t_clean=0.15; 
% thresholds.t_noisy=0.29;
% thresholds.t_recon=0.14;
% thresholds.t_diff=0.14;

%----------------------------------------------------------------------------

% Experiment 3 (in paper)
% sigma = 30;
% degree = 3;
% delta = 7000; 
% type_of_polynomials = 1; %standard basis
% 
% name_of_image='cameraman.png';
% 
% [signal_characteristics]=lib_add_noise_to_image(sigma, name_of_image);
% 
% param_method.lambda = 1; 
% param_solver.maxit = 500;       % maximum number of iterations
% 
% thresholds.t_clean=0.25; 
% thresholds.t_noisy=0.29;
% thresholds.t_recon=0.18;
% thresholds.t_diff=0.16;

% ------------------------------------------------------------------------
% Experiment 4 (in paper)
% sigma = 30;
% degree = 3;
% delta = 8000; 
% type_of_polynomials = 1; %standard basis
% 
% name_of_image='rice.png';
% 
% [signal_characteristics]=lib_add_noise_to_image(sigma, name_of_image);
% 
% param_method.lambda = 1; 
% param_solver.maxit = 500;       % maximum number of iterations
% 
% thresholds.t_clean=0.24; 
% thresholds.t_noisy=0.4;
% thresholds.t_recon=0.2;
% thresholds.t_diff=0.18;

% -----------------------------------------------------------------------

% compute edges

param_method.epsilon_ball = delta;
signal_characteristics.degree = degree;
[signal_characteristics] = edge_detect_2D(param_solver, param_method, signal_characteristics, type_of_polynomials);

% plot results
plot_images(signal_characteristics, thresholds);

